This project might be open to known security vulnerabilities, which can be prevented by tightening the version range of affected dependencies. Find detailed information at the bottom.

Crate tower-lsp

Dependencies

(16 total, 1 outdated, 1 possibly insecure)

CrateRequiredLatestStatus
 async-codec-lite^0.00.0.2up to date
 async-trait^0.10.1.80up to date
 auto_impl^1.01.2.0up to date
 bytes^1.01.6.0up to date
 dashmap^5.15.5.3up to date
 futures^0.30.3.30up to date
 httparse^1.81.9.4up to date
 lsp-types^0.94.10.97.0out of date
 memchr^2.52.7.4up to date
 serde^1.01.0.203up to date
 serde_json^1.01.0.117up to date
 tokio ⚠️^1.171.38.0maybe insecure
 tokio-util^0.70.7.11up to date
 tower^0.40.4.13up to date
 tower-lsp-macros^0.90.9.0up to date
 tracing^0.10.1.40up to date

Dev dependencies

(5 total, 2 outdated, 1 possibly insecure)

CrateRequiredLatestStatus
 async-tungstenite^0.220.26.2out of date
 tokio ⚠️^1.171.38.0maybe insecure
 tokio-util^0.70.7.11up to date
 tracing-subscriber^0.30.3.18up to date
 ws_stream_tungstenite^0.100.13.0out of date

Security Vulnerabilities

tokio: reject_remote_clients Configuration corruption

RUSTSEC-2023-0001

On Windows, configuring a named pipe server with pipe_mode will force ServerOptions::reject_remote_clients as false.

This drops any intended explicit configuration for the reject_remote_clients that may have been set as true previously.

The default setting of reject_remote_clients is normally true meaning the default is also overridden as false.

Workarounds

Ensure that pipe_mode is set first after initializing a ServerOptions. For example:

let mut opts = ServerOptions::new();
opts.pipe_mode(PipeMode::Message);
opts.reject_remote_clients(true);